﻿// The following code was generated by Microsoft Visual Studio 2005.
// The test owner should check each test for validity.
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;
using System.Text;
using System.Collections.Generic;
using System.Collections;

namespace TestProjectCalculator
{
    /// <summary>
    ///This is a test class for BaseCalculator.AnalaizerClass and is intended
    ///to contain all BaseCalculator.AnalaizerClass Unit Tests
    ///</summary>
    [TestClass()]
    public class AnalaizerClassTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }
        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        /// A test for RunEstimate ()
        /// Проверяем, что, если в стеке находится корректное выражение, представленное обратной польской записью, то
        /// метод RunEstimate правильно посчитает это выражение
        ///</summary>
        [DeploymentItem("BaseCalculator.exe")]
        [TestMethod()]
        public void RunEstimateTest()
        {
            string expected = "3";
            string actual;
            TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.opz = new ArrayList();
            ArrayList _opz = TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.opz;
            _opz.Add("7");
            _opz.Add("8");
            _opz.Add("+");
            _opz.Add("5");
            _opz.Add("/");

            actual = TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.RunEstimate();

            Assert.AreEqual(expected, actual, "BaseCalculator.AnalaizerClass.RunEstimate did not return the expected value.");
        }


        /// <summary>
        ///A test for CheckCurrency ()
        /// Проверяет, что, если в выражении нарушена скобочная структура, то метод возвращает false
        ///</summary>
        [DeploymentItem("BaseCalculator.exe")]
        [TestMethod()]
        public void CheckCurrencyTest()
        {
            bool expected = false;
            bool actual;
            TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.expression = "((5+3)*2-(3*10))-2)+((5+3)";


            actual = TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.CheckCurrency();

            Assert.AreEqual(expected, actual, "BaseCalculator.AnalaizerClass.CheckCurrency did not return the expected value.");
            Assert.AreEqual(18, TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.erposition, "BaseCalculator.AnalaizerClass.CheckCurrency did not return the expected value.");
        }

        /// <summary>
        ///A test for CreateStack ()
        /// Проверяет, что если отформатированное выражение равно "( ( 5 + 3 ) * 2 - ( 3 * 10 ) ) - 2 + ( 5 + 3 ) ", 
        /// то стек содержит следующие элементы"5 3 + 2 * 3 10 * - 2 - 5 3 + + "
        ///</summary>
        [DeploymentItem("BaseCalculator.exe")]
        [TestMethod()]
        public void CreateStackTest()
        {
            string expected = "5 3 + 2 * 3 10 * - 2 - 5 3 + + ";
            ArrayList actual;

            TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.expression = "( ( 5 + 3 ) * 2 - ( 3 * 10 ) ) - 2 + ( 5 + 3 ) ";


            actual = TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.CreateStack();

            string actualstr = "";
            foreach (object obj in actual)
            {
                actualstr += obj.ToString() + " ";
            }
            Assert.AreEqual(expected, actualstr, "BaseCalculator.AnalaizerClass.CreateStack did not return the expected value.");
        }

        /// <summary>
        ///A test for Estimate ()
        /// Проверяет, что , если на выражение , которое необходимо проверить равно ((5+3)*2-(3*10))-2+(5+3), то метод вернет его значение,
        /// равное -8
        ///</summary>
        [DeploymentItem("BaseCalculator.exe")]
        [TestMethod()]
        public void EstimateTest()
        {
            string expected = "-8";
            string actual;

            TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.expression = "((5+3)*2-(3*10))-2+(5+3)";
            actual = TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.Estimate();

            Assert.AreEqual(expected, actual, "BaseCalculator.AnalaizerClass.Estimate did not return the expected value.");
            
        }

        /// <summary>
        ///A test for Format ()
        /// Проверяет, что если выражение равно "((5+3)*2-(3  *10))-2+ (5+3)", то метод отформатирует его к виду:
        /// "( ( 5 + 3 ) * 2 - ( 3 * 10 ) ) - 2 + ( 5 + 3 ) "
        ///</summary>
        [DeploymentItem("BaseCalculator.exe")]
        [TestMethod()]
        public void FormatTest()
        {
            string expected = "( ( 5 + 3 ) * 2 - ( 3 * 10 ) ) - 2 + ( 5 + 3 ) ";
            string actual;
            TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.expression = "((5+3)*2-(3  *10))-2+ (5+3)";
            actual = TestProjectCalculator.BaseCalculator_AnalaizerClassAccessor.Format();
    
            Assert.AreEqual(expected, actual, "BaseCalculator.AnalaizerClass.Format did not return the expected value.");
           
        }

    }


}
